.nolist
#include "ion.inc"
#include "get.inc"		;thanks Brandon (Engelberth)!
.list
shipx = saferam3		;your ship's x coordinate
bulletx = saferam3+1		;x coordinate of your bullet
bullety = saferam3+2		;y coord of your bullet
aliensx = saferam3+3		;base x coordinate of aliens
aliensy = saferam3+4		;y cood of aliens
aliensdir = saferam3+7		;direction the aliens are moving (either 1 or -1)
alienaddr = saferam3+8		;the address of the current alien sprite (word)
counter = saferam3+11		;counter for slowing the ships down
hitsa1 = saferam3+12		;hits remaining until alien 1 is dead
hitsa2 = saferam3+13		;you guessed it
hitsa3 = saferam3+14		;...
hitsa4 = saferam3+15		;...
hitsa5 = saferam3+16		;...
level = saferam3+20		;current level (word)
shotx = saferam3+30		;x coord of alien shot
shoty = saferam3+31		;y coord of alien shot
score = saferam3+50		;current score (word)
randvar = saferam3+52		;used by rand
#ifdef TI83P
	.org    progstart-2
	.db     $BB,$6D
#else
	.org    progstart
#endif
	ret
	jr      nc,start
        .db     "Alien v1.0 (for ion)",0
start:
 ld	a,44			;initialize ship's x coord so that it starts in the middle of the screen
 ld	(shipx),a
 xor    a
 ld	(counter),a
 ld	hl,0
 ld	(level),hl
 ld	(score),hl
 ld	(shotx),hl
 ld	(bulletx),hl
 call   set_up_level		;execute set_up_level subroutine
keyloop:
 call   try_shot		;see if one of the aliens can shoot, if so, set up the shot
 call   draw_ship		;draw the blaster
 call   update_bullets 		;update all of the bullets
 ld	a,(counter)		;counter loops 0-7
 inc	a
 and	%111			;keep it 7 or below
 ld	(counter),a
 cp	1			;update aliens only if counter is 1, otherwise they go too fast
 call   z,update_aliens
 bcall(_grbufcpy)  		;copy GRAPH_MEM to lcd
 call   check_for_win		;check to see if all of the aliens are dead
 ld	a,(aliensy)		;if aliens get too low, you die
 cp	47
 jr	z,died
 ld     a,0ffh			;some of this keyscanning routine was yanked from Spaze Invaders 83 by movax
 out    (1),a
 ld     a,0feh
 out    (1),a
 in     a,(1)
 cp     253			;unless you get 253 back, Left isn't down
 jr	nz,NOLEFT
 ld	a,(shipx)
 or     a			;ship can't go off the screen
 jr	z,NOLEFT
 ld	hl,shipx
 dec    (hl)			;decrement Ship's X coordinate
NOLEFT:
 cp      251
 jr	nz,NORIGHT		;Right isn't down if it's not 251
 ld	a,(shipx)
 cp     88			;can't go off the screen to the right either
 jr	z,NORIGHT
 ld	hl,shipx
 inc    (hl)			;increment Ship's X coordinate
NORIGHT:
 ld     a,0ffh			;reset the port
 out    (1),a
 ld     a,0fdh			;load mask for Clear key (among others)
 out    (1),a			;send it to the port
 in     a,(1)			;get the results back
 cp     191			;check for Clear's Status
 jr	nz,NOCLR
 ret
NOCLR:
 ld     a,0ffh			;reset port 1
 out    (1),a	
 ld	a,0bfh			;load mask for 2nd key (among others)
 out	(1),a			;send it to the port
 in     a,(1)			;get the resultant byte
 cp	223			;check to see if 2nd is down
 jr	nz,NO2ND
 ld	a,(bullety)		;if so, try shooting a "friendly" bullet
 or     a
 jr	nz,NO2ND		;if bullety isn't 0 (ie there is a bullet already in the air) you can't shoot
 ld	a,55
 ld	(bullety),a		;put 55 into bullety
 ld	a,(shipx)
 add	a,3			;put ship's x coord + 3 into bulletx
 ld	(bulletx),a
NO2ND:
 ld     a,0ffh			;reset the port
 out    (1),a
 ld	a,0bfh			;load another mask
 out	(1),a			;"send" it to the port
 in     a,(1)			;get something back
 cp	191			;test for mode key
 jr	nz,NOMODE
 call   status_screen		;if mode is pressed, show status screen
NOMODE:
 jp     keyloop

died:
 ld	hl,$1921		;set up coords for printing "You Died!"
 ld	(pencol),hl
 ld	hl,dead
 bcall(_vputs)		;print "You Died!" in menu style font
 bcall(_getcsc)
 cp	tRIGHT		;otherwise you might not see this screen
 jr	z,died
 cp	tLEFT
 jr	z,died
 ret

check_for_win:
 ld	hl,hitsa1		;load address of hitsa1 (number of hits left for alien 1)
 ld	b,5			;there are 5 aliens
check_loop:
 ld	a,(hl)
 or     a			;see if hitsax is 0
 ret	nz			;if it isn't there are more aliens to hit/kill
 inc	hl			;increment hl to get the address of the hit counter for the next alien
 djnz	check_loop		;loop
 ld	hl,(level)		;then it increments the level
 inc	hl
 ld	(level),hl
 call   set_up_level		;set up new level
 ret

status_screen:
 LD 	a,1		;set up the coords for displaying the score
 LD 	(currow),a
 ld     a,7
 ld     (curcol),a
 ld	hl,(score)
 bcall(_disphl)  		;display score
 LD 	a,1		;set up coords for displaying "Score:"
 LD 	(currow),a
 ld	a,0
 ld	(curcol),a
 ld	hl,scorestr
 bcall(_puts)			;write "Score:"
 LD 	a,2		;set up the coords for displaying the level
 LD 	(currow),a
 ld	a,7
 ld	(curcol),a	
 ld	hl,(level)		;put level into hl
 inc	hl			;increment it because 0=1, 1=2, 2=3 etc
 bcall(_disphl)  		;display level
 LD 	a,2		;set up coords for displaying "Level:"
 ld	(currow),a
 ld	a,0
 ld	(curcol),a
 ld	hl,levelstr
 bcall(_puts)			;write "Level:"
 bcall(_getkey) 		;wait for key
 ret				;and return

update_aliens:
 ld	a,(aliensx)
 cp	24			;if aliensx (x coord of leftmost alien) is 24, we've hit the right edge and need to turn around
 jr	z,go_to_neg
 or     a			;if it is 0, it has hit the right, again we need to turn around
 jr	z,go_to_pos
 jr	no_dir_switch		;if it is niether of these, we don't have o do anything
go_to_pos:
 ld	a,1
 ld	(aliensdir),a		;make aliensdir (what is added to aliensx) 1
 jr	onward
go_to_neg:
 ld	a,-1
 ld	(aliensdir),a		;make aliensdir -1
onward:
 ld	a,(aliensy)		;move ships down one pixel
 inc	a
 ld	(aliensy),a
no_dir_switch:
 call   erase_aliens		;erase the aliens
 ld	a,(aliensdir)		;add aliensdir to aliensx
 ld	b,a
 ld	a,(aliensx)
 add	a,b
 ld	(aliensx),a
 call   draw_aliens		;put the aliens back
 ret

draw_ship:			;draws the ship at (shipx,56)
 ld	a,(shipx)
 ld	b,a
 ld	c,56
 ld	hl,ship
 call   PutSprite
 ret

set_up_level:
 bcall(_grbufclr)		;clear GRAPH_MEM
 ld	a,12
 ld	(aliensx),a		;starting coodrinate of aliens is 12
 ld	a,(level)
 add	a,4
 ld	(aliensy),a		;level+4 goes into y-coord of aliens
 ld	a,(level)
 inc	a
 sra	a			;level/2
 or     a			;if it is 0, we have to make it 1
 jr	nz,fine			;otherwise it is fine
 inc	a			;make it 1
fine:
 ld	h,a			;put level/2 into hitsa(1-5)
 ld	l,a
 ld	(hitsa1),hl
 ld	(hitsa3),hl
 ld	(hitsa5),a
 ld	a,r			;ld a with r register
 and	3			;get it 3 or below
 ld	hl,alien1		;get address of first alien sprite
 add	a,a			;times 2
 add	a,a			;times 4
 add	a,a			;times 8 (8 bytes per sprite)
 ld	d,0
 ld	e,a			;put shipnum*8 into de
 add	hl,de			;add that to the address of the first alien sprite
 ld	(alienaddr),hl		;and you have the address of the current alien sprite
 ld	a,1
 ld	(aliensdir),a		;set aliensdir to 1 (aliens move in a positive x direction to start with)
 call   draw_ground		;draw pattern on bottom
 call   draw_aliens		;draw the aliens
 ret

erase_aliens:
 ld	b,5			;there are 5 aliens
erase_loop:
 push	bc
 dec	b			;but they are "numbered" 0-4
 ld	a,b
 add	a,a			;*2
 add	a,a			;*4
 add	a,a			;*8
 add	a,a			;*16
 ld	c,a
 ld	a,(aliensx)		
 add	a,c			;add offset calcualted above, so we get the x coord of the proper alien (according to the loop counter)
 ld	b,a
 ld	a,(aliensy)		
 ld	c,a			;put aliensy into c
 ld	hl,blank		;we are putting a blank sprite
 call   PutSprite		;now put it
 pop	bc
 djnz	erase_loop
 ret

draw_aliens:
 ld	hl,hitsa5		;address of hits left on alien5
 ld	b,5			;5 aliens
draw_loop:
 push	hl
 ld	a,(hl)
 cp	0
 jr	z,dont_draw		;if there are no hits left (alien is killed) don't draw it
 push	bc
 dec	b
 ld	a,b			;look at explanation for similar routine in erase_aliens (could they be consolidated into 1 to save space? go for it :)
 add	a,a
 add	a,a
 add	a,a
 add	a,a
 ld	c,a
 ld	a,(aliensx)
 add	a,c
 ld	b,a
 ld	a,(aliensy)
 ld	c,a
 ld	hl,(alienaddr)
 call   PutSprite
 pop	bc
dont_draw:
 pop	hl
 dec	hl
 djnz	draw_loop
 ret

update_bullets:
 call   alien_shot		;update alien shot
 ld	a,(bullety)
 cp	2			;if bullety is 2, it is close enough to the top of the screen to call it quits
 jp     c,hit_top
 ld	a,(bulletx)
 ld	b,a
 ld	a,(bullety)
 ld	c,a
 ld	hl,blankbul
 call   PutSprite		;put blank 2x2 sprite at (bulletx,bullety)
 ld	a,(bullety)
 dec	a
 ld	(bullety),a		;move bullet up a pixel
 ld	b,a
 ld	a,(aliensy)
 add	a,8
 cp	b
 jr	c,skip_test		;if bullety is not less than aliensy+8, we can go ahead and skip the hit test (there's nothing to hit except alien bullets which are handled later on)
 ld	a,(bulletx)
 ld	b,a
 ld	a,(bullety)
 ld	c,a
 call   GetPixel 		;check pixel at *new* (bulletx,bullety)
 or     a
 jr	nz,hit_alien		;if we don't get a 0 back, an alien has bee hit
skip_test:
 ld	a,(bulletx)
 ld	b,a
 ld	a,(bullety)
 ld	c,a
 ld	hl,bullet		;put bullet at (bulletx,bulety)
 call   PutSprite
 ld	hl,bulletx
 call	LD_HL_MHL
 ex	de,hl
 ld	hl,shotx
 call	LD_HL_MHL
 call	CP_HL_DE		;check if word at bulletx (contains both bulletx and bullety) equals word at shotx (contains both x and y coords as it is a word)
 jr	z,hit_bullet		;if so, we hit another bullet
 ret
hit_alien:
 ld	hl,score		;add 1 to score
 inc	(hl)
 call   detect_which_one	;detect which alien has been hit
 jr	hit_top
hit_bullet:
 ld	hl,$0000
 ld	(shotx),hl		;re-initialize shotx and shoty
hit_top:
 ld	a,(bulletx)
 ld	b,a
 ld	a,(bullety)
 ld	c,a
 ld	hl,blankbul
 call   PutSprite		;erase 2x2 square at bulletx,bullety
 ld	hl,$0000
 ld	(bulletx),hl		;put 0 into both bulletx and bullety
 ret
alien_shot:
 ld	a,(shotx)		;same idea as the routine above that updates friendly bullets (perhaps another chance for consolidation? :)
 or     a
 jr	z,hit_bot
 ld	a,(shoty)
 or     a
 jr	z,hit_bot
 cp	58
 jr	z,hit_bot
 ld	a,(shotx)
 ld	b,a
 ld	a,(shoty)
 ld	c,a
 ld	hl,blankbul
 call   PutSprite
 ld	a,(shoty)
 inc	a
 ld	(shoty),a
 ld	b,a
 ld	a,56
 cp	b
 jr	nc,skip_test1
 ld	a,(shotx)
 ld	b,a
 ld	a,(shoty)
 inc	a
 ld	c,a
 call   GetPixel
 or     a
 jr	nz,hit_ship

skip_test1:
 ld	a,(shotx)
 ld	b,a
 ld	a,(shoty)
 ld	c,a
 ld	hl,bullet
 call   PutSprite
 ret

hit_bot:
 ld	a,(shotx)
 ld	b,a
 ld	a,(shoty)
 ld	c,a
 ld	hl,blankbul
 call   PutSprite
 ld	hl,$0000
 ld	(shotx),hl
 ret
hit_ship:
 call   died
 inc	sp			;so it will return to the shell rather than keyloop
 inc	sp
 inc	sp
 inc	sp
 ret

try_shot:			;see if any alien can shoot and set it up accordingly
 ld	a,(shotx)
 or     a
 jr	nz,cant_shoot
 ld	a,(shoty)
 or     a
 jr	nz,cant_shoot
 ld	a,(aliensx)
 ld	d,a
 call   ionRandom
 ld	b,d
 and 	3
 bit	2,d
 jr	z,dont_inc
 inc	a
dont_inc:
 ld	c,a
 ld	hl,hitsa1
 ld	d,0
 ld	e,a
 add	hl,de
 ld	a,(hl)
 or     a
 jr	z,cant_shoot
 ld	a,c
 add	a,a
 add	a,a
 add	a,a
 add	a,a
 add	a,b
 add	a,3
 ld	(shotx),a
 ld	a,(aliensy)
 add	a,6
 ld	(shoty),a
cant_shoot:
 ret

detect_which_one:
 ld	a,(aliensx)
 ld	b,a
 ld	a,(bulletx)
 sub	b
 sra	a
 sra	a
 sra	a
 sra	a
 ld	d,0
 ld	e,a
 ld	hl,hitsa1
 add	hl,de
 ld	a,(hl)
 or     a
 ret	z
 dec	a
 ld	(hl),a
 ret

rand:				;by Chris Busch
 ld    a,(randvar)
 ld    b,a
 xor   a
 add   a,b
 sla   b
 sla   b
 add   a,b
 sla   b
 sla   b
 add   a,b
 inc   a
 ld    (randvar),a
 srl   a
 ret

draw_ground:
 ld	b,12
 ld	e,0
gnd_loop:
 push	bc
 ld	c,60
 ld	b,e
 ld	hl,ground
 push	de
 call   PutSprite
 pop	de
 ld	a,e
 add	a,8
 ld	e,a
 pop	bc
 djnz	gnd_loop
 ret

PutSprite: ; Puts a sprite stored at (HL) at B,C  (by Jimmy Mardell)
 push 	bc
 push 	de
 ld 	a,63
 sub 	c
 ld 	c,a
 push 	hl
 push 	hl
 call 	FIND_PIXEL
 ld 	de,GRAPH_MEM
 add 	hl,de
 ex 	de,hl
 pop 	hl
 ld 	b,(hl)
 inc 	hl
 ld 	c,(hl)
 inc 	hl
 push 	hl
 pop 	ix
 ex 	de,hl
PS_NewRow:
 push 	bc
 ld 	d,(ix)
 inc 	ix
 push 	af
 push 	hl
PS_NewCol:
 rl 	d
 ld 	e,a
 jr 	nc,PS_NoPixel
 or 	(hl)
 ld 	(hl),a
 jr 	PS_NextPixel
PS_NoPixel:
 cpl
 and 	(hl)
 ld 	(hl),a
PS_NextPixel:
 ld 	a,e
 rrca
 jr 	nc,PS_SameByte
 inc 	hl
PS_SameByte:
 djnz 	PS_NewCol
 pop 	hl
 pop 	af
 ld 	de,12
 add 	hl,de
 pop 	bc
 dec 	c
 jr 	nz,PS_NewRow
 pop 	hl
 pop 	de
 pop 	bc
 ret

GetPixel:			;returns 0 only if the pixel is off, otherwise you get a non-zero value
 ld	a,63
 sub	c
 ld	c,a
 push 	bc
 call 	FIND_PIXEL
 ld 	b,a
 push	hl
 pop	de
 ld	hl,GRAPH_MEM
 add	hl,de
 ld	a,(hl)
 and	b
 pop	bc
 ret


;-------------------------------------------------------------------------------
;FIND_PIXEL Routine, by Patrick Davidson [From Zkart3d 82]
;-------------------------------------------------------------------------------
FIND_PIXEL_DATA:
         .db      128,64,32,16,8,4,2,1
FIND_PIXEL:
         push     bc
         ld       a,b
         and      7
         ld       hl,FIND_PIXEL_DATA
         ld       e,a
         ld       d,0
         add      hl,de
         ld       e,(hl)            ; E = pixel mask
         ld       a,63
         sub      c
         ld       c,a
         add      a,a
         add      a,c               ; A = 3 * Y
         ld       l,a
         ld       h,0
         add      hl,hl
         add      hl,hl             ; HL = 12 * Y
         ld       a,b
         ld       b,0
         rrca
         rrca
         rrca
         and      15
         ld       c,a
         add      hl,bc
         ld       a,e               ; A = pixel mask
         pop      bc
         ret

CP_HL_DE:		;By Matt Shepcar
  push hl
  or a
  sbc hl,de
  pop hl
  ret

LD_HL_MHL:				;thanks, Terry_P!
 push de
 ld e,(hl)
 inc hl
 ld d,(hl)
 pop hl
 ex de,hl
 ret

.include alienspr.txt

dead:
 .db "You Died!",0
levelstr:
 .db "Level:",0
scorestr:
 .db "Score:",0
.end
